﻿Imports System
Imports System.IO
Imports System.Text
Imports Ivi.Visa.Interop
Imports System.Runtime.InteropServices
Imports ZedGraph 

Public Class form
    Dim myMgr As ResourceManager = New ResourceManager
    Dim myScope As FormattedIO488 = New FormattedIO488


    Dim Point1() As Byte
    Dim Point2() As Byte
    Dim Point3() As Byte
    Dim Point4() As Byte

    Dim Pane As GraphPane

    Dim list1 As PointPairList = New PointPairList()
    Dim list2 As PointPairList = New PointPairList()
    Dim list3 As PointPairList = New PointPairList()

    Dim MyPoints As List(Of Array) = New List(Of Array)
    Dim MyPointsTypeInstruction As List(Of String) = New List(Of String)


    Dim HammingToDictionnary() As Integer = {0, 32, 5, 97, 154, 182, 246, 253, 255}
 

    Dim myStreamWriter As StreamWriter
    Dim LineBlinking As Integer = 0

    Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

    Private Sub RefreshScale()
        myScope.WriteString(":TIMebase:SCALe?")
        BaseTemps.Text = "Time: " & myScope.ReadString().Trim & " s"

        myScope.WriteString(":CHANnel1:SCALe?")
        BaseVoie1.Text = "Scale Channel 1 : " & myScope.ReadString().Trim & " V/div"

        myScope.WriteString(":CHANnel2:SCALe?")
        BaseVoie2.Text = "Scale Channel 2 : " & myScope.ReadString().Trim & " V/div"

        myScope.WriteString(":CHANnel3:SCALe?")
        BaseVoie3.Text = "Scale Channel 3 : " & myScope.ReadString().Trim & " V/div"

        myScope.WriteString(":CHANnel4:SCALe?")
        BaseVoie4.Text = "Scale Channel 4 : " & myScope.ReadString().Trim & " V/div"

    End Sub

    Private Sub Form_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        Pane = Graph.GraphPane

        ListMaterial.DataSource = myMgr.FindRsrc("?*INSTR")
        Actions.Enabled = False


        ListMaterial.Enabled = False
        myScope.IO = myMgr.Open(ListMaterial.Text, AccessMode.NO_LOCK, 1000, "")
        myScope.IO.Timeout = 10000


        Dim cmd As String = "*IDN?"
        myScope.WriteString(cmd, True)
        Dim responseString As String = myScope.ReadString()
        Etat.Text = responseString

        myScope.WriteString(":WAVEFORM:POINTS 30000")
        myScope.WriteString(":WAVeform:POINts:MODE NORMal")
        RefreshScale()
        btn_CaptureSecondCurrent.Enabled = False
        Actions.Enabled = True
    End Sub
    Private Sub btn_CatchRefNop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_CatchRefNop.Click
        btn_CatchRefNop.Enabled = False
        DeleteCurves()

        myScope.WriteString(":RUn")
        System.Threading.Thread.Sleep(3000)
        myScope.WriteString(":STOp")

        myScope.WriteString(":WAVeform:SOURce CHANnel3")
        myScope.WriteString(":WAVeform:DATA?")
        System.Threading.Thread.Sleep(1500)
        Point1 = myScope.ReadIEEEBlock(IEEEBinaryType.BinaryType_UI1)

        myScope.WriteString(":WAVeform:SOURce CHANnel2")
        myScope.WriteString(":WAVeform:DATA?")
        System.Threading.Thread.Sleep(1500)
        Point2 = myScope.ReadIEEEBlock(IEEEBinaryType.BinaryType_UI1)


        myScope.WriteString(":WAVeform:SOURce CHANnel1")
        myScope.WriteString(":WAVeform:DATA?")
        System.Threading.Thread.Sleep(1500)
        Point3 = myScope.ReadIEEEBlock(IEEEBinaryType.BinaryType_UI1)

        Pane.Title.Text = "Reference of current"
        Pane.XAxis.Title.Text = "Number of point"
        Pane.YAxis.Title.Text = "Measure"

        list1.Clear()
        list2.Clear()
        list3.Clear()



        For i As Integer = 0 To Point1.Length - 1
            list1.Add(CType(i, Double), CType(Point1(i), Double))
            list2.Add(CType(i, Double), CType(Point2(i), Double))
            list3.Add(CType(i, Double), CType(Point3(i), Double))
        Next

        Dim Courbe1 As LineItem = Pane.AddCurve("Reference of current", list1, Color.Red, SymbolType.None)
        Dim Courbe2 As LineItem = Pane.AddCurve("Synchronisation", list2, Color.Green, SymbolType.None)
        Dim Courbe3 As LineItem = Pane.AddCurve("Clock", list3, Color.Blue, SymbolType.None)

        Graph.AxisChange()
        Graph.Refresh()

        btn_CaptureSecondCurrent.Enabled = True
        btn_CatchRefNop.Enabled = True
    End Sub

    Private Sub btn_CaptureSecondCurrent_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_CaptureSecondCurrent.Click

        btn_CaptureSecondCurrent.Enabled = False
        DeleteCurves()
        myScope.WriteString(":RUn")
        System.Threading.Thread.Sleep(3000)
        myScope.WriteString(":STOp")

        myScope.WriteString(":WAVeform:SOURce CHANnel3")
        myScope.WriteString(":WAVeform:DATA?")
        System.Threading.Thread.Sleep(2000)
        Point4 = myScope.ReadIEEEBlock(IEEEBinaryType.BinaryType_UI1)


        myScope.WriteString(":WAVeform:SOURce CHANnel2")
        myScope.WriteString(":WAVeform:DATA?")
        System.Threading.Thread.Sleep(1500)
        Point2 = myScope.ReadIEEEBlock(IEEEBinaryType.BinaryType_UI1)


        myScope.WriteString(":WAVeform:SOURce CHANnel1")
        myScope.WriteString(":WAVeform:DATA?")
        System.Threading.Thread.Sleep(1500)
        Point3 = myScope.ReadIEEEBlock(IEEEBinaryType.BinaryType_UI1)



        Pane.Title.Text = "Differential Current"
        Pane.XAxis.Title.Text = "Number of point"
        Pane.YAxis.Title.Text = "Measure"


        list1.Clear()
        list2.Clear()
        list3.Clear()

        For i As Integer = 0 To Point4.Length - 1
            list1.Add(CType(i, Double), (CType(Point4(i), Double) - CType(Point1(i), Double)))
            list2.Add(CType(i, Double), (CType(Point2(i), Double)))
            list3.Add(CType(i, Double), (CType(Point3(i), Double)))
        Next

        Pane.AddCurve("Differential Current", list1, Color.Red, SymbolType.None)
        Pane.AddCurve("Synchronisation", list2, Color.Green, SymbolType.None)
        Pane.AddCurve("Clock", list3, Color.Blue, SymbolType.None)

        Graph.AxisChange()
        Graph.Refresh()
        btn_CaptureSecondCurrent.Enabled = True
    End Sub


    Private Sub DeleteCurves()
        For i As Integer = (Pane.CurveList.Count - 1) To 0 Step -1
            Pane.CurveList.RemoveAt(i)
        Next
        Graph.AxisChange()
        Graph.Refresh()
    End Sub

    Private Sub btn_run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_run.Click
        myScope.WriteString(":RUn")
    End Sub

    Private Sub btn_stop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_stop.Click
        myScope.WriteString(":STOp")
    End Sub

    Private Sub envoi_instruction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_SendInstruction.Click
        btn_SendInstruction.Enabled = False
        MyPoints.Clear()

        For Counter As Integer = 0 To HammingToDictionnary.Count - 1
            ChangeCode("movlw 0x" & HammingToDictionnary(Counter).ToString("X"), "NOP")
            MakeCode()
            SendCode()
            ShowCurrent("MOVLW hamming: " & NbToHamming(HammingToDictionnary(Counter)) & ",NOP")
        Next

        'For Counter As Integer = 0 To HammingToDictionnary.Count - 1
        '    ChangeCode("CLRF 0x" & HammingToDictionnary(Counter).ToString("X"), "NOP")
        '    MakeCode()
        '    SendCode()
        '    ShowCurrent("CLRF hamming: " & NbToHamming(HammingToDictionnary(Counter)) & ",NOP")
        'Next

        'For Counter As Integer = 0 To HammingToDictionnary.Count - 1
        '    ChangeCode("NEGF 0x" & HammingToDictionnary(Counter).ToString("X"), "NOP")
        '    MakeCode()
        '    SendCode()
        '    ShowCurrent("NEGF hamming: " & NbToHamming(HammingToDictionnary(Counter)) & ",NOP")
        'Next

        'For Counter As Integer = 0 To HammingToDictionnary.Count - 1
        '    ChangeCode("SETF 0x" & HammingToDictionnary(Counter).ToString("X"), "NOP")
        '    MakeCode()
        '    SendCode()
        '    ShowCurrent("SETF hamming: " & NbToHamming(HammingToDictionnary(Counter)) & ",NOP")
        'Next

        'For Counter As Integer = 0 To HammingToDictionnary.Count - 1
        '    ChangeCode("movlw 0x" & HammingToDictionnary(Counter).ToString("X"), "movwf TRISB")
        '    MakeCode()
        '    SendCode()
        '    ShowCurrent("MOVLW hamming: " & NbToHamming(HammingToDictionnary(Counter)) & ", MOVWF TRISB")
        'Next

        'For Counter As Integer = 0 To HammingToDictionnary.Count - 1
        '    ChangeCode("movlw 0x" & HammingToDictionnary(Counter).ToString("X"), "NEGF W")
        '    MakeCode()
        '    SendCode()
        '    ShowCurrent("MOVLW hamming: " & NbToHamming(HammingToDictionnary(Counter)) & ", NEGF W")
        'Next

        Try
            myStreamWriter = New StreamWriter(Environment.CurrentDirectory & "\Dictionnary.csv")

            For Curve As Integer = 0 To MyPoints.Count - 1
                myStreamWriter.Write(MyPointsTypeInstruction(Curve) & ";")
                For Point As Integer = 0 To CType(MyPoints.Item(0), Array).Length - 1
                    If Point = CType(MyPoints.Item(0), Array).Length - 1 Then
                        myStreamWriter.Write(CType(MyPoints.Item(Curve), Array).GetValue(Point))
                    Else
                        myStreamWriter.Write(CType(MyPoints.Item(Curve), Array).GetValue(Point) & ";")
                    End If
                Next
                myStreamWriter.WriteLine("")
            Next
            myStreamWriter.Close()
        Catch ex As Exception
            Console.WriteLine(ex.Message)
        End Try

        btn_SendInstruction.Enabled = True
    End Sub

    Private Sub ChangeCode(ByVal instruction1 As String, ByVal instruction2 As String)
        Try
            Dim myStreamWriter As StreamWriter = New StreamWriter(Environment.CurrentDirectory & "\projetasm.asm")
            myStreamWriter.Write(SourceCode.Text.Replace("<instruction1>", instruction1).Replace("<instruction2>", instruction2))
            myStreamWriter.Close()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub


    Private Sub MakeCode()
        Dim p As New ProcessStartInfo
        p.FileName = "mpasmwin.exe"
        p.Arguments = " -q -p18F4620 """ & Environment.CurrentDirectory & "\projetasm.asm"""
        p.WindowStyle = ProcessWindowStyle.Hidden
        Dim leProcess As Process = Process.Start(p)
        Do While Not leProcess.HasExited
        Loop
    End Sub

    Private Sub SendCode()
        Dim p As New ProcessStartInfo
        p.FileName = Environment.CurrentDirectory & "\RealICECMD.exe"
        p.Arguments = "  -E -L -M P C -P18F4620 -F""" & Environment.CurrentDirectory & "\projetasm.HEX"""
        '   p.WindowStyle = ProcessWindowStyle.Hidden
        Dim leProcess As Process = Process.Start(p)
        'wait to process finish
        Do While Not leProcess.HasExited
        Loop
    End Sub

    Private Sub ShowCurrent(ByVal NomInstruction As String)
        Dim Point1 As Byte()

        myScope.WriteString(":RUn")
        System.Threading.Thread.Sleep(4800)
        myScope.WriteString(":STOp")

        myScope.WriteString(":WAVeform:SOURce CHANnel3")
        myScope.WriteString(":WAVeform:DATA?")
        System.Threading.Thread.Sleep(2000)
 
        Point1 = myScope.ReadIEEEBlock(IEEEBinaryType.BinaryType_UI1)
        MyPoints.Add(Point1)

        MyPointsTypeInstruction.Add(NomInstruction)
    End Sub

   
    Private Function NbToHamming(ByVal Nb As Integer)
        Dim text As String = Convert.ToString(CLng(Nb), 2)
        Dim Hamming As Integer = 0
        For Each bit As Char In text
            If bit = "1" Then
                Hamming = Hamming + 1
            End If
        Next
        Return Hamming
    End Function

    Private Sub Timer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer.Tick
        If GraphicalResults.Rows(LineBlinking).DefaultCellStyle.SelectionForeColor = Color.Red Then
            GraphicalResults.Rows(LineBlinking).DefaultCellStyle.SelectionForeColor = Color.White
            GraphicalResults.Rows(LineBlinking).DefaultCellStyle.BackColor = Color.White
        Else
            GraphicalResults.Rows(LineBlinking).DefaultCellStyle.SelectionForeColor = Color.Red
            GraphicalResults.Rows(LineBlinking).DefaultCellStyle.BackColor = Color.Red
        End If
    End Sub



    Private Sub btn_GraphicalFindInstruction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_GraphicalFindInstruction.Click
        btn_GraphicalFindInstruction.Enabled = False

        GraphicalResults.Rows.Clear()
        Dim Hamming0() As String = {"00"}
        Dim Hamming1() As String = {"01", "02", "04", "08", "10", "20", "40", "80"}
        Dim Hamming2() As String = {"03", "05", "06", "09", "0A", "0C", "11", "12", "14", "18", "21", "22", "24", "28", "30", "41", "42", "44", "48", "50", "60", "81", "82", "84", "88", "90", "A0", "C0"}
        Dim Hamming3() As String = {"07", "0B", "0D", "0E", "13", "15", "16", "19", "1A", "1C", "23", "25", "26", "29", "2A", "2C", "31", "32", "34", "38", "43", "45", "46", "49", "4A", "4C", "51", "52", "54", "58", "61", "62", "64", "68", "70", "83", "85", "86", "89", "8A", "8C", "91", "92", "94", "98", "A1", "A2", "A4", "A8", "B0", "C1", "C2", "C4", "C8", "D0", "E0"}
        Dim Hamming4() As String = {"0F", "17", "1B", "1D", "1E", "27", "2B", "2D", "2E", "33", "35", "36", "39", "3A", "3C", "47", "4B", "4D", "4E", "53", "55", "56", "59", "5A", "5C", "63", "65", "66", "69", "6A", "6C", "71", "72", "74", "78", "87", "8B", "8D", "8E", "93", "95", "96", "99", "9A", "9C", "A3", "A5", "A6", "A9", "AA", "AC", "B1", "B2", "B4", "B8", "C3", "C5", "C6", "C9", "CA", "CC", "D1", "D2", "D4", "D8", "E1", "E2", "E4", "E8", "F0"}
        Dim Hamming5() As String = {"1F", "2F", "37", "3B", "3D", "3E", "4F", "57", "5B", "5D", "5E", "67", "6B", "6D", "6E", "73", "75", "76", "79", "7A", "7C", "8F", "97", "9B", "9D", "9E", "A7", "AB", "AD", "AE", "B3", "B5", "B6", "B9", "BA", "BC", "C7", "CB", "CD", "CE", "D3", "D5", "D6", "D9", "DA", "DC", "E3", "E5", "E6", "E9", "EA", "EC", "F1", "F2", "F4", "F8"}
        Dim Hamming6() As String = {"3F", "5F", "6F", "77", "7B", "7D", "7E", "9F", "AF", "B7", "BB", "BD", "BE", "CF", "D7", "DB", "DD", "DE", "E7", "EB", "ED", "EE", "F3", "F5", "F6", "F9", "FA", "FC"}
        Dim Hamming7() As String = {"7F", "BF", "DF", "EF", "F7", "FB", "FD", "FE"}
        Dim Hamming8() As String = {"FF"}


        Dim Instruction1() As String = {"MOVLW", "CLRF", "SETF", "NEGF"}
        Dim Instruction2_Data() As String = {"NOP", "MOVWF TRISB", "MOVWF LATB", "NEGF W"}


        GraphicalResults.Rows.Add("0", "", "", "")
        GraphicalResults.Rows.Add("1", "", "", "")
        GraphicalResults.Rows.Add("2", "", "", "")
        GraphicalResults.Rows.Add("3", "", "", "")
        GraphicalResults.Rows.Add("4", "", "", "")
        GraphicalResults.Rows.Add("5", "", "", "")
        GraphicalResults.Rows.Add("6", "", "", "")
        GraphicalResults.Rows.Add("7", "", "", "")
        GraphicalResults.Rows.Add("8", "", "", "")


        CType(GraphicalResults.Rows(0).Cells(1), DataGridViewComboBoxCell).DataSource = Instruction1
        CType(GraphicalResults.Rows(1).Cells(1), DataGridViewComboBoxCell).DataSource = Instruction1
        CType(GraphicalResults.Rows(2).Cells(1), DataGridViewComboBoxCell).DataSource = Instruction1
        CType(GraphicalResults.Rows(3).Cells(1), DataGridViewComboBoxCell).DataSource = Instruction1
        CType(GraphicalResults.Rows(4).Cells(1), DataGridViewComboBoxCell).DataSource = Instruction1
        CType(GraphicalResults.Rows(5).Cells(1), DataGridViewComboBoxCell).DataSource = Instruction1
        CType(GraphicalResults.Rows(6).Cells(1), DataGridViewComboBoxCell).DataSource = Instruction1
        CType(GraphicalResults.Rows(7).Cells(1), DataGridViewComboBoxCell).DataSource = Instruction1
        CType(GraphicalResults.Rows(8).Cells(1), DataGridViewComboBoxCell).DataSource = Instruction1


        CType(GraphicalResults.Rows(0).Cells(2), DataGridViewComboBoxCell).DataSource = Hamming0
        CType(GraphicalResults.Rows(1).Cells(2), DataGridViewComboBoxCell).DataSource = Hamming1
        CType(GraphicalResults.Rows(2).Cells(2), DataGridViewComboBoxCell).DataSource = Hamming2
        CType(GraphicalResults.Rows(3).Cells(2), DataGridViewComboBoxCell).DataSource = Hamming3
        CType(GraphicalResults.Rows(4).Cells(2), DataGridViewComboBoxCell).DataSource = Hamming4
        CType(GraphicalResults.Rows(5).Cells(2), DataGridViewComboBoxCell).DataSource = Hamming5
        CType(GraphicalResults.Rows(6).Cells(2), DataGridViewComboBoxCell).DataSource = Hamming6
        CType(GraphicalResults.Rows(7).Cells(2), DataGridViewComboBoxCell).DataSource = Hamming7
        CType(GraphicalResults.Rows(8).Cells(2), DataGridViewComboBoxCell).DataSource = Hamming8

        CType(GraphicalResults.Rows(0).Cells(3), DataGridViewComboBoxCell).DataSource = Instruction2_Data
        CType(GraphicalResults.Rows(1).Cells(3), DataGridViewComboBoxCell).DataSource = Instruction2_Data
        CType(GraphicalResults.Rows(2).Cells(3), DataGridViewComboBoxCell).DataSource = Instruction2_Data
        CType(GraphicalResults.Rows(3).Cells(3), DataGridViewComboBoxCell).DataSource = Instruction2_Data
        CType(GraphicalResults.Rows(4).Cells(3), DataGridViewComboBoxCell).DataSource = Instruction2_Data
        CType(GraphicalResults.Rows(5).Cells(3), DataGridViewComboBoxCell).DataSource = Instruction2_Data
        CType(GraphicalResults.Rows(6).Cells(3), DataGridViewComboBoxCell).DataSource = Instruction2_Data
        CType(GraphicalResults.Rows(7).Cells(3), DataGridViewComboBoxCell).DataSource = Instruction2_Data
        CType(GraphicalResults.Rows(8).Cells(3), DataGridViewComboBoxCell).DataSource = Instruction2_Data



        Dim Point1 As Byte()

        myScope.WriteString(":RUn")
        System.Threading.Thread.Sleep(4500)
        myScope.WriteString(":STOp")

        myScope.WriteString(":WAVeform:SOURce CHANnel3")
        myScope.WriteString(":WAVeform:DATA?")
        System.Threading.Thread.Sleep(2000)
        Point1 = myScope.ReadIEEEBlock(IEEEBinaryType.BinaryType_UI1)


        Dim Array1 As List(Of Integer) = New List(Of Integer)
        Dim ArrayNameInstruction As List(Of String) = New List(Of String)

        Try

            Dim monStreamReader As StreamReader = New StreamReader(Environment.CurrentDirectory & "\Dictionnary.csv")
            Dim Line As String

            Do
                Dim LaLigne As String()
                Line = monStreamReader.ReadLine()
                If Not (Line Is Nothing) Then
                    LaLigne = Line.Split(";")

                    Dim NbNullBit As Integer = 0
                    Dim counterLine As Integer = 0

                    For Each Number As String In LaLigne
                        If counterLine <> 0 Then
                            If (Math.Abs(Number - Point1(counterLine - 1)) <= 1) Then '3 is sensibility of difference
                                NbNullBit = NbNullBit + 1
                            End If
                        End If
                        counterLine = counterLine + 1
                    Next
                    Array1.Add(NbNullBit)
                    ArrayNameInstruction.Add(LaLigne(0))
                End If
            Loop Until Line Is Nothing
            monStreamReader.Close()

            Dim linstruction As String = ArrayNameInstruction(Array1.IndexOf(Array1.Max))


            Dim HammingFound As Integer = linstruction.Split(",").First.Split(" ").Last().ToString
            Dim Intruction1 As String = linstruction.Split(",").First.Split(" ").First().ToString
            Dim Intruction2 As String = linstruction.Split(",").Last

            LineBlinking = HammingFound

            GraphicalResults.Rows(HammingFound).Cells(1).Value = Trim(Intruction1)
            GraphicalResults.Rows(HammingFound).Cells(2).Value = Trim(HammingFound)
            GraphicalResults.Rows(HammingFound).Cells(3).Value = Trim(Intruction2)
            Console.WriteLine(Trim(Intruction2))
        Catch ex As Exception
            MsgBox(ex.Message)
            btn_GraphicalFindInstruction.Enabled = True
        End Try
        btn_GraphicalFindInstruction.Enabled = True
        Timer.Enabled = True
    End Sub

    Private Sub TableauTrouverGraphique_DataError(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewDataErrorEventArgs) Handles GraphicalResults.DataError
        Console.WriteLine(e.Exception)
    End Sub
End Class
